# coding: utf-8

module Morchi

  # The Disk class
  class Disk
    include(Comparable)
    
    # Raw value.
    DISC_RAW = { empty: 0, black: 1, white: 2 }

    # Property.
    attr_reader :raw

    # Initialize.
    def initialize(raw)
      @raw = DISC_RAW[raw]
    end

    # (Comparable) Require implemented.
    def <=>(other)
      raw <=> other.raw
    end

    # 
    def to_s
      DISC_RAW.invert[@raw].to_s
    end

    %i(empty black white).each do |color|
      instance_variable_set("@#{color}", Disk.new(color))
      class_eval <<-EOL
        def #{color}?
          self == self.class.#{color}
        end

        def self.#{color}
          instance_variable_get("@#{color}")
        end
      EOL
    end
  end
end
